function [row1, col1, Remain] = find_row_col (AllSeq, searchR)
% this function searches for nucleotide seqeunce withing AllSeq array
% the function returns the row/col coordinates for the found string within
% the AllSeq array, and returns that Remain array in which all rows that
% contained the found seqeunce were removed.

if ~iscell(AllSeq)
    % convert char array ot sequences to cell array of strings
    RET   =  char(10*ones(size(AllSeq,1),1));
    test2 = textscan(sprintf('%s\n', [AllSeq RET]'), '%s');
    clear AllSeq;
    AllSeq = test2{1};
end
    
pos = strfind(AllSeq, searchR);  

ix=cellfun('isempty', pos);
row1 = find(ix==0);
col1 = cellfun(@(x) x(1), pos(row1));
Remain = find(ix);


end
