function [searchO,TAGO] = makemutants(search,TAG)

% Make nucleotides with one point mutation
for j=1:2
    searchM={};
    for i=1:numel(search{j})

       temp = { 
           [search{j}(1:i-1) 'A' search{j}(i+1:end)];
           [search{j}(1:i-1) 'T' search{j}(i+1:end)];
           [search{j}(1:i-1) 'C' search{j}(i+1:end)];
           [search{j}(1:i-1) 'G' search{j}(i+1:end)] };
       
       searchM = [searchM; temp];
    end  
    
    [~,~,REM] = find_row_col (searchM, search{j});
    searchM = searchM(REM);
    
    tempTAG = cell(size(searchM));
    if j==1
        tempTAG(:) = {'<F> <1MUT> '};
    elseif j==2
        tempTAG(:) = {'<R> <1MUT> '};
    end
    
    
    search = [search; searchM];
    TAG    = [TAG; tempTAG];
end

% % make 1N-containing nucleotides %%%%%%%%%%%%%%
for j=1:2
    searchM={};
    for i=1:numel(search{j})
        searchM = [searchM; [search{j}(1:i-1) 'N' search{j}(i+1:end)] ];
    end
    
    tempTAG = cell(size(searchM));
    if j==1
        tempTAG(:) = {'<F> <OneN> '};
    elseif j==2
        tempTAG(:) = {'<R> <OneN> '};
    end
    
    search = [search; searchM];
    TAG    = [TAG; tempTAG];
end
 searchO = search;
 TAGO = TAG;

end