function [OUT] = parseq(cSeq, cQua, searchF, searchR, BARL, NNKL, marker, SORT)

% quality string contains return character at the end; delete it

if double(cQua(1,end)==10)
    cQua = cQua(:,1:end-1);
end
if double(cSeq(1,end)==10)
    cSeq = cSeq(:,1:end-1);
end

% %%%%%% Create nucleotide information in this section

search = {searchF; searchR };
TAG = {'<F> <PERF> '; '<R> <PERF> ' };

[search,TAG] = makemutants(search,TAG);


    %%%%% Search for all adapters %%%%%%%%%%%
    sTAG= numel(TAG{1});
    maxC = BARL + NNKL + 1;
    tempT = char(46*ones(size(cSeq,1),sTAG ) );
    tempS = char(46*ones(size(cSeq,1),size(cSeq,2)+maxC-1));
    tempQ = tempS;
    Nold = 0;
    
    for ii=1:numel(search)
        
        % find rows and columns where adaptors are located
        [rowF, colF, RemI] = find_row_col (cSeq, search{ii});
        MAX = max(colF);

        for j=1:MAX
             IX = find( colF == j );
             N = numel(IX);
             LIM=(Nold+1:1:Nold+N );
             
             tempS(LIM,:) = [char(46*ones(N,maxC-j)) ...
                             cSeq(rowF(IX),max((j-maxC+1),1):end) ...
                             char(46*ones(N,j-1)) ] ;
                         
             tempQ(LIM,:) = [char(46*ones(N,maxC-j)) ...
                             cQua(rowF(IX),max((j-maxC+1),1):end) ...
                             char(46*ones(N,j-1)) ] ;
                         
             Nold = Nold + N;

            for jj=1:numel(TAG{ii})
                tempT(LIM,jj) = TAG{ii}(jj);
            end 

        end

    %the information that remained after removing the found strings
    cSeq    = cSeq(RemI,:);
    cQua = cQua(RemI,:);

    end
    
    % trim the file
    tempT = tempT(1:Nold,:);
    tempS = tempS(1:Nold,:);
    tempQ = tempQ(1:Nold,:);
    
    % find the region where the library starts
    offset = BARL + NNKL + numel(search{1})+1;
    LTAG = char(44*ones(size(tempS,1),numel(marker(1).name)));
    
    % find all forward reads; map the library type
    IF = find(tempT(:,2)=='F');
    LTAG(IF,:) = maplib(tempS(IF,offset:end), 'F', marker, 'P12');
    
    % repeat for reverse reads
    IR = find(tempT(:,2)=='R');
    LTAG(IR,:) = maplib(tempS(IR,offset:end), 'R', marker, 'P12');


RET = char(10*ones(size(tempS,1),1));
SP  = char(32*ones(size(tempS,1),1));
RET(end) = ' ';
LibL = size(LTAG,2);
AllL = size(tempS,2);

OUT = [LTAG SP tempT ...
        tempS(:,1:NNKL) SP ...
        tempS(:,NNKL+1:NNKL+BARL) SP ...
        tempS(:,NNKL+BARL+1:offset-1) SP ...
        tempS(:,offset:AllL) SP SP ...
        tempQ(:,1:NNKL) SP ...
        tempQ(:,NNKL+1:NNKL+BARL) SP ...
        tempQ(:,NNKL+BARL+1:offset-1) SP ...
        tempQ(:,offset:end) RET];    

if SORT
    [~, IX] = sortrows([OUT(:,1:LibL+sTAG) OUT(:,offset:LibL+AllL)]);
    OUT = OUT(IX,:);
end
    
end
