function unionFR(varargin)

number=0;
%check for input variable
if exist('varargin','var')
    L = length(varargin);
    if rem(L,2) ~= 0, error('Parameters/Values must come in pairs.'); 
    end

    % read input variables
    for ni = 1:2:L
        switch lower(varargin{ni})
            case 'inname1', inname1 = varargin{ni+1};
            case 'inname2', inname2 = varargin{ni+1};    
            case 'outname', outname = varargin{ni+1};
            case 'number', number=varargin{ni+1};
        end
    end
end

%%%%%%%%%%%%% End of the Input Section %%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic
    fh = fopen(inname1,'r');
    AllVar = textscan(fh,'%s %*s %d %*[^\n]');
    NUC1 = AllVar{1};
    FR1  = AllVar{2};

    fh = fopen(inname2,'r');
    AllVar = textscan(fh,'%s %*s %d %*[^\n]');
    NUC2 = AllVar{1};
    FR2  = AllVar{2};
    clear('AllVar');
    fclose all;
    timeW = num2str(toc,3);
    disp(['loaded sequences in ' timeW ' seconds']);
    
    %calculate the intersect, select the maximum frequency
    [INTER, IX, IX2] = intersect(NUC1,NUC2);
    inFr = max(FR1(IX),FR2(IX2));
    clear('IX2');
    
    % calculate differences and frequencies of differences
    [dFNUC,IX] = setdiff(NUC1,NUC2);
    FR1 = FR1(IX);
    
    [dRNUC,IX] = setdiff(NUC2,NUC1);
    FR2 = FR2(IX);
    clear('NUC1','NUC2');
    timeW = num2str(toc,3);
    disp(['calculated intersect and differences in ' timeW ' seconds']);
    
    % combine all the nucleotides and frequencies
    NUC = [INTER; dFNUC; dRNUC];
    FR  = [inFr ; FR1;  FR2 ];
    clear('INTER','dFNUC','dRNUC','inFR','FR1','FR2');
    
    [FR,IX] = sort(FR,'descend');
    NUC=NUC(IX);

    sNUC = char(NUC);  
    [PEP,~] = nt2aacell(sNUC,1:size(sNUC,2),0,1);
        
    test2=textscan(sprintf('%d\n', FR), '%s');
    clear('FR','NUC');
    cFr=char(test2{1});

    RET  = char (10*ones(size(sNUC,1),1));
    SP   = char (32*ones(size(sNUC,1),5));
    RET(end) = ' ';
    uTOT = numel(RET);
        
    toSave=[sNUC SP PEP SP cFr RET];
    clear('sNUC','SP','cFr','RET');
    
    fprintf( fopen(outname, 'w'), '%s\r\n', toSave');
    fclose all;
    clear('toSave');
    timeW = num2str(toc,3);
        disp([inname1(end-18:end) 'total time: ' timeW ]);
      
end
    
% function [CELL] = char2cell (CHAR)
%     RET   =  char(10*ones(size(CHAR,1),1));
%     RET(end) = ' ';
%     test2 = textscan(sprintf('%s\n', [CHAR RET]'), '%s');
%     CELL = test2{1};
% end
