clear all;

% [~,~,a] = xlsread('mimoset.xls');
% save('mimoDB.mat','a');

% % the above two lines do not work on Mac, you have to run them on PC
% % there is a problem with xlsread on non-PC platforms. 

load('mimoDB.mat')

a=a(2:end,:);

seq  = a(:,2);
Nseq = cell2mat(a(:,4));
ref  = a(:,11);
%%% fix the reference format to strings
for i=1:numel(ref)
    if isnumeric(ref{i})
        ref{i}=num2str(ref{i});
    end
end

lib  = cell2mat(a(:,7));
REMOVEC = 0;  % by default, do not remove flanking Cs

%%% unquote this portion to generate PhD12 data
% savename = 'PhD12-literature.txt';
% INDphdXX = find(lib==1);

%%% unquote this portion to generate PhD7 data
savename = 'PhD7-literature.txt';
INDphdXX = find(lib==2);

%%% unquote this portion to generate C7C data
% savename = 'C7C-literature.txt';
% REMOVEC = 1;
% INDphdXX = find(lib==3);

seq12 = seq(INDphdXX);
ref12 = ref(INDphdXX);


[ref12,IX]=sort(ref12);
seq12 = seq12(IX);
[uref12,IX] = unique(ref12,'first');
IX2= [IX(2:end); numel(ref12)];
Fr = IX2-IX;
for i=1:numel(Fr)
    if Fr(i)>1
        for j=1:Fr(i)
            ref12{IX(i)+j-1}=[ref12{IX(i)+j-1} '___' num2str(j) ];
        end
    end
end

%%%% find the longest reference and sequence

LONGESTREF=1;
LONGESTSEQ=30;

for i=1:numel(ref12)
    if LONGESTREF<numel(ref12{i});
        LONGESTREF=numel(ref12{i});
    end

end

EXTseq12 = {};
EXTref12={};

TOT=[];
for j=1:numel(seq12)
    
    current=seq12{j};
    
    
    
    SEQ={};
    FR=[];
    
    
    % break the entry into pieces separated by RET character (char10)
    
    sep = [0 strfind(current,char(10)) numel(current)+1];
    for i=2:numel(sep)
        SEQ{i-1} = current(sep(i-1)+1:sep(i)-1);
    end
        
    % check each sequence one by one
    for m=1:numel(SEQ)
        
        bracket1 = strfind(SEQ{m},'(');
        bracket2 = strfind(SEQ{m},')');
    

        % does entry have brackets?
        if isempty(bracket1) | isempty(bracket2)
            FR(m)  = 1;
        else
            FR(m)  = str2num(SEQ{m}(bracket1+1:bracket2-1));
            SEQ{m} = SEQ{m}(1:bracket1-1);
        end
        
        % trim really long sequences
        if numel(SEQ{m})>20
            SEQ{m}= [SEQ{m}(1:20) '??check??'];
        end
        
        % remove C if necessary
        if REMOVEC
            % check whether sequence has flanking C's
            if SEQ{m}(1)=='C' || SEQ{m}(1)=='c'
                SEQ{m}=SEQ{m}(2:end);
            end
            if SEQ{m}(end)=='C' || SEQ{m}(end)=='c'
                SEQ{m}=SEQ{m}(1:end-1);
            end
        end
    end

    
    if sum(FR>=1)==numel(FR)
        nFr = FR/sum(FR);
    else
        nFr = FR;
    end
    
    
    SP1 = char(32*ones(1,(LONGESTREF+4)-numel(ref12{j})));
    
    for i=1:numel(FR)
        SP2 = char(32*ones(1,(LONGESTSEQ+4) - numel(SEQ{i})));
        cFr = num2str(FR(i));
        SP3 = char(32*ones(1,10 - numel(cFr)));
        cnFr= num2str(nFr(i),'%0.3f');
        SP4 = char(32*ones(1,10 - numel(cnFr)));
        RET = char(10);
        currentline = [SEQ{i} SP2 cFr SP3 cnFr SP4 ref12{j} SP1 RET];
        TOT = [TOT; currentline];
    end
end


        
    fh = fopen(savename, 'w');
        fprintf(fh, '%s\r\n', TOT');
    fclose all;
