function callback_function(hO,~)

%determina which button has called the function
TAG = get(hO,'Tag');

%find which button group has called the function
N = str2num(TAG(end));
TAG = TAG (1:end-1);

% find the parent window and parent button group
PG = get(hO,'Parent');
PW = get(PG,'Parent');

visibilitySwitch('off');  
pause(0.0001); 
% for some reason visibility switch doesn't work without pause.

switch TAG
    case 'Browse',                  Browse(hO,PW,PG,N)
    case 'Preview Menu2',            Preview(hO,PW,PG,N)
    case 'OverlapPreviewMenu',      PreviewOverlap(hO,PW,PG)
    case 'Load Data',               Load(hO,PW,PG,N)
    case 'Select input',            inputformat(hO,PW,PG,N)
    case 'Plot Zebra',              Plotzebra(hO,PW,PG,N)
    case 'X-Y-scatter',             Scatter(hO,PW,PG,N)
    case 'Venn D.',                 Venn(hO,PW,PG,N)
    case 'XuY',                     disp('its on'); Comparison(hO,PW,PG,N); 
    case 'XnY',                     Comparison(hO,PW,PG,N)        
    case 'YnX',                     Comparison(hO,PW,PG,N)    
    case 'X/Y',                     Comparison(hO,PW,PG,N)    
    case 'Y/X',                     Comparison(hO,PW,PG,N)    
    case 'Compare',                 Comparison(hO,PW,PG,N)  
    case 'Save',                    Save(hO,PW,PG,N)
end

visibilitySwitch('on')

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function visibilitySwitch(values)

    a = findobj;

    for i=1:numel(a)
        if isprop(a(i), 'style')
            if isequal(get(a(i), 'style'),'pushbutton')
                set(a(i), 'Visible',values);
            end
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Browse(~,PW,PG,N)

    H = guidata(PW);
    i=1;
    
    if isfield(H,'DIR') 
        while isempty(H.DIR{i})
            i=i+1;  % move to the next DIR element
        end
        [FILE,DIR,FilterIndex] = uigetfile('*.txt','Select file',H.DIR{i}); 
    else
        [FILE,DIR,FilterIndex] = uigetfile('*.txt','Select file');
    end
    if ~FilterIndex  %check for pressing cancel
        return;
    end

    %set_flags(FILE,DIR_raw);
    Name = findobj(PG,'-regexp', 'Tag', 'File Name\w*');
    set(Name,'String',FILE);

    % store the FILE and DIR in figure's application data
    % to make it recoverabe by external fun3ctions
    
    handles = guidata(PW);
    handles.FILE{N} = FILE;
    handles.DIR{N} = DIR;
    handles.Browse{N} = 1;
    guidata(PW,handles);

    % find the object named "Preview Window"; clear it
    Name = findobj(PG,'-regexp', 'Tag', 'Preview Window\w*');
    set(Name, 'String', '');

    % find the preview dropdown menu and trigger it
    Name = findobj(PG,'-regexp', 'Tag', 'Preview Menu\w*');
    Preview(Name,PW,PG,N)
    
    Name = findobj(PG,'-regexp', 'Tag', 'Load Data\w*');
    set(Name, 'BackgroundColor',[0 1 0]);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Preview(hO,PW,PG,N)
    
    H = guidata(PW);
    temp = get(hO,'Value');
    switch temp
        case 1, NL=10; %number of lines to read
        case 2, NL=100; %number of lines to read
        case 3, NL=1000; %number of lines to read
        case 4, NL=Inf; %number of lines to read
    end
    
    H.Browse{N};
    
    if isfield(H,'Fr') && isfield(H,'Nuc') && ~H.Browse{N}
        
        %check the length
        if NL>numel(H.Fr{N})
            NL=numel(H.Fr{N});
        end
        
        cFr = num2str(H.Fr{N}(1:NL));
        SP  = char(32*ones(NL,5));
        STRING=[char(H.Nuc{N}(1:NL,:)) SP cFr];
        
    elseif ~isfield(H,'FILE') && ~isfield(H,'DIR')
        return; % no internal variables and no file to read from
        
    elseif ~isdir(char(H.DIR{N}))  
        return; % if defined directory is not a directory
    else
        FID = fopen(fullfile(H.DIR{N}, H.FILE{N}));
        if FID==-1
            return; % file does not exist
        end
        
        if ~isinf(NL)
           currL2=cell(NL,1);
           for i=1:NL 
               if ~feof(FID)  
                    currL2{i} = fgetl(FID);
               end
           end
           STRING=char(currL2');
           
        else
            fseek(FID,0,'eof');
            NL = ftell(FID);  % position of the last element of the file
            frewind(FID);
            currL2 = fread(FID,'*uint8');
            STRING=char(currL2');
        end
        
        
    end
    
    % find the object named "Preview Window"   
    Name = findobj(PG,'-regexp', 'Tag', 'Preview Window\w*');
    
    % place the first N strings from file into the Preview Window
    set(Name, 'Max', NL);
    try
        set(Name, 'String', STRING);
    catch
       set(Name, 'String', ['File is too large to display.';...
                            'set "view" to 10, 100 or 1000']);    
    end
    set(Name, 'FontName', 'FixedWidth');
    set(Name, 'FontSize', 10);
end

function PreviewOverlap(hO,PW,PG)
    
    H = guidata(PW);
    if ~isfield(H,'cFr') && ~isfield(H,'cNuc')
        return;
    end
    
    temp = get(hO,'Value');
    switch temp
        case 1, NL=10; %number of lines to read
        case 2, NL=100; %number of lines to read
        case 3, NL=1000; %number of lines to read
        case 4, NL=numel(H.cNuc); %number of lines to read
    end

    Name = findobj(PG,'-regexp', 'Tag', 'OverlapPreviewWindow\w*');
    
    try
        cFr = num2str(H.cFr(1:NL,:));
        SP  = char(32*ones(NL,5));
        set(Name, 'String', [char(H.cNuc(1:NL,:)) SP cFr]);
    catch
       set(Name, 'String', ['File is too large to display.';...
                            'set "view" to 10, 100 or 1000']);    
    end
    set(Name, 'FontName', 'FixedWidth');
    set(Name, 'FontSize', 10);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Load(hO,PW,PG,N)

    Name = findobj(PG,'-regexp', 'Tag', 'Select input\w*');
    inputformat(Name,PW,PG,N);

    H = guidata(PW);
    
    FH = fopen(fullfile(H.DIR{N}, H.FILE{N}), 'r+');
    AllVar = textscan(FH,H.inputformat{N});
    if numel(H.readfields{N})==1
        Fr = AllVar{H.readfields{N}};
        Nuc = char(32*ones(size(Fr)));
    elseif numel(H.readfields{N})>1
        Nuc = AllVar{H.readfields{N}(1)};
        Fr = AllVar{H.readfields{N}(2)};
    end
    clear 'AllVar';
    fclose(FH);
        
    % clean up the variables. Remove NaNs or blanks
    
    findNAN = find(isnan(Fr));
    if ~isempty(findNAN)
        IX=setdiff(1:1:numel(Fr),findNAN);
        Fr=Fr(IX);
        Nuc=Nuc(IX);
    end
    
    % place the content of the file into the internal variables
    H.Nuc{N} = Nuc;
    H.Fr{N} = Fr;
    H.Browse{N} = 0;
    guidata(PW,H);

    % find the object named "Preview Menu" and trigger it;
    Name = findobj(PG,'-regexp', 'Tag', 'Preview Menu\w*');
    Preview(Name,PW,PG,N);

    Name = findobj(PG,'-regexp', 'Tag', 'Unique\w*');
    set(Name,'String',['Uni=' num2str(numel(Fr))] );

    Name = findobj(PG,'-regexp', 'Tag', 'Total\w*');
    set(Name,'String',['Tot=' num2str(sum(Fr))] );
    
    set(hO, 'BackgroundColor',[0.9 0.9 0.9]);

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function inputformat(hO,PW,~,N)

    H = guidata(PW);
    val = get(hO,'Value');

    if val == 1
        H.inputformat{N} = '%s %*s %f %*[^\n]';
        H.readfields{N} = [1 2];
    elseif val == 2
        H.inputformat{N} = '%*s %s %f %*[^\n]';
        H.readfields{N} = [1 2];
    elseif val == 3
        H.inputformat{N} = '%*s %*s %f %*[^\n]';
        H.readfields{N} = 1;
    end
    guidata(PW,H);
        
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Comparison(hO,PW,PG,N)

    H = guidata(PW);

    if ~isfield(H,'Fr') && ~isfield(H,'Nuc')
        return;
    end
    
    if numel(H.Fr)<N
        return;
    end
    
    TAG = get(hO,'Tag');
    TAG = TAG (1:end-1);
    
    switch TAG
        case 'XuY', ACT=1; N1=1; N2=2;
        case 'XnY', ACT=2; N1=1; N2=2;
        case 'YnX', ACT=3; N1=2; N2=1;
        case 'X/Y', ACT=4; N1=1; N2=2;
        case 'Y/X', ACT=5; N1=2; N2=1;  
        case 'Compare', ACT=6; N1=1; N2=2; 
    end
    
    % calculate unique elements
    [H.Nuc{N1}, H.Fr{N1}, ~] = uniqueCOMB (H.Nuc{N1}, H.Fr{N1});
    [H.Nuc{N2}, H.Fr{N2}, ~] = uniqueCOMB (H.Nuc{N2}, H.Fr{N2});

    tic;
    %calculate the intersect, select the maximum frequency
    [INTER, IX, IX2] = intersect(H.Nuc{N1},H.Nuc{N2});
    if ACT==1
        inFr = max([H.Fr{N1}(IX) H.Fr{N2}(IX2)],[],2);
    elseif ACT==6
        inFr = [H.Fr{N1}(IX) H.Fr{N2}(IX2)];
    else
        inFr = H.Fr{N1}(IX);
    end
    clear('IX2');
    
    % calculate differences and frequencies of differences
    [dFNUC,IX] = setdiff(H.Nuc{N1},H.Nuc{N2});
    FR1 = H.Fr{N1}(IX);
    
    [dRNUC,IX] = setdiff(H.Nuc{N2},H.Nuc{N1});
    FR2 = H.Fr{N2}(IX);

    timeW = num2str(toc,3);
    disp(['calculated intersect and differences in ' timeW ' seconds']);
    
    if ACT == 1
        % combine all the nucleotides and frequencies
        H.cNuc = [INTER; dFNUC; dRNUC];
        H.cFr  = [inFr ; FR1;  FR2 ];
    elseif ACT == 2 || ACT == 3
        H.cNuc = INTER;
        H.cFr  = inFr;
    elseif ACT == 4 || ACT == 5
        H.cNuc = dFNUC;
        H.cFr  = FR1;
    elseif ACT == 6
        H.cNuc = [INTER; dFNUC; dRNUC];
        H.cFr  = [inFr ; ...
                  [FR1 zeros(size(FR1))]; ... 
                  [zeros(size(FR2)) FR2] ];
    end
  
    clear('INTER','dFNUC','dRNUC','inFR','FR1','FR2');
    
    [~,IX] = sort(H.cFr(:,1),'descend');
    H.cFr  = H.cFr (IX,:);
    H.cNuc = H.cNuc(IX);
    
    % write the data to the internal variable
    guidata(PW,H);

    Name = findobj(PG,'-regexp', 'Tag', 'OverlapPreviewMenu\w*');
    PreviewOverlap(Name,PW,PG);
    
    Name = findobj(PG,'-regexp', 'Tag', 'OverlapUnique\w*');
    set(Name,'String',['Uni=' num2str(numel(H.cFr))] );

    Name = findobj(PG,'-regexp', 'Tag', 'OverlapTotal\w*');
    set(Name,'String',['Tot=' num2str(sum(H.cFr))] );
 
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Plotzebra(~,PW,PG,N)

    H = guidata(PW);

    if ~isfield(H,'Fr') && ~isfield(H,'Nuc')
        return;
    end
    
    if numel(H.Fr)<N
        return;
    end
    
    L = 1;                           % default length
    W=0.1;
    x1= -0.2;  x2= 5;                  % default width of canvas
    y1= -1; y2= 2;                   % default height of canvas

    H1 = figure(100);                     % defined the figure
    textheight=0.05;
    Font = 'Monospaced';
    
    NNKvalue = get(findobj(PG,'-regexp', 'Tag', 'NNK\w*'),'Value'); 
    normalval = get(findobj(PG,'-regexp', 'Tag', 'Normal\w*'),'Value'); 
    mirrorval = get(findobj(PG,'-regexp', 'Tag', 'Mirror\w*'),'Value'); 
    horizval = get(findobj(PG,'-regexp', 'Tag', 'Horizont\w*'),'Value');
    x0 = str2num(get(findobj(PG,'-regexp', 'Tag', 'x0\w*'),'String'));
    y0 = str2num(get(findobj(PG,'-regexp', 'Tag', 'y0\w*'),'String'));
    
    if ~isnumeric(x0) && ~isnumeric(x0)
        return
    end
    
    if horizval
        orientation = 'horizontal';
    else
        orientation = 'vertical';
    end
    
    if normalval
       segment=[0 
         0.0000003 
         0.000001 
         0.000003 
         0.00001 
         0.00003 
         0.0001 
         0.0003 
         0.001
         0.003
         0.01 
         0.03
         0.1
         0.3
         1];  
    else
       segment=[1
           3
           10
           30
           100 
           300 
           1000 
           3000 
           10000 
           30000 
           100000 
           300000
           1000000
           30000000];
    end

    values2deepzebra('Fr',H.Fr{N},'Nuc',H.Nuc{N},...
       'segment', segment,...
       'dimension','2D',...
       'xy00', [x0 y0],'xlim', [x1 x2], 'ylim', [y1 y2],... 
       'title','',...
       'length', L, 'width', W,'mirror',mirrorval,...
       'color', 'jet',...
       'orientation', orientation,...
       'FigureHandle', H1,...
       'findunique', 1, 'addlabel',0,'addtotal',1,...
       'NNKonly',NNKvalue,'normalized',normalval,...
       'textheight',textheight,'font',Font); 

end  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Scatter(~,PW,~,~)

    H = guidata(PW);

    if ~isfield(H,'Fr') || ~isfield(H,'Nuc')
        return;
    end
    
    if numel(H.Fr)~=2 || numel(H.Fr)~=2
        return
    end;

    H1 = figure(200);                     % defined the figure
    normal = get(findobj(PW,'-regexp', 'Tag', 'Normal\w*'),'Value');
    normalX = normal{2};
    normalY = normal{1};
    flipXY = get(findobj(PW,'-regexp', 'Tag', 'FlipXY\w*'),'Value');
    SymAxis = get(findobj(PW,'-regexp', 'Tag', 'SymAxis\w*'),'Value');
    isratio= get(findobj(PW,'-regexp', 'Tag', 'RatioScatter\w*'),'Value');
  
    values2scatter('Xfreq', H.Fr{1},'Yfreq', H.Fr{2},...
                    'Xseq', H.Nuc{1},'Yseq', H.Nuc{2},...
                    'outname', '',...
                    'normalizedX',normalX,'normalizedY',normalY,...
                    'resize',1,'FigureHandle', H1,......
                    'namex', H.FILE{1}, 'namey', H.FILE{2},...
                    'FlipXY',flipXY,'PlotRatio',isratio,...
                    'SymAxis',SymAxis);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Venn(~,PW,~,~)

    H = guidata(PW);

    if ~isfield(H,'Fr') || ~isfield(H,'Nuc')
        return;
    end
    
    if numel(H.Fr)~=2 || numel(H.Fr)~=2
        return
    end;

    H1 = figure(300);                     % define the figure
    
    values2venndia('Xfreq', H.Fr{1},'Yfreq', H.Fr{2},...
                    'Xseq', H.Nuc{1},'Yseq', H.Nuc{2},...
                    'outname', '',...
                    'resize',1,'FigureHandle', H1,......
                    'namex', H.FILE{1}, 'namey', H.FILE{2});
end



function Save(~,PW,~,~)

    H = guidata(PW);
    i=1;
    
    if ~isfield(H,'cFr') || ~isfield(H,'cNuc') 
        return;
    end
    
    [filename, pathname, filterindex] = uiputfile(...
             {'*.txt';'*.*'},...
             'Save as');
    
    if ~filterindex  %check for pressing cancel
        return;
    end
    
    cFr = num2str(H.cFr);
    SP  = char(32*ones(numel(H.cNuc),5));
    RET = char(10*ones(numel(H.cNuc),1));
    
    NUC = char(H.cNuc);
    PEP = nt2aacell(NUC,1:size(NUC,2),0,1); 
    
    toSave = [NUC SP PEP SP cFr RET];
    
    
    clear('cFr','SP');
    
    disp(['about to save to' fullfile(pathname,filename)]);
    fh = fopen(fullfile(pathname,filename), 'w');
    fprintf( fh, '%s\r\n', toSave');
    fclose all;
    clear('toSave');
    
end

function [aac,ntc] = nt2aacell(nt,L,REV,Qfix)
 
if iscell(nt)
  ntc = char(nt); 
else
    ntc=nt;
end
clear('nt');


if REV
    ntc = fliplr(ntc);

    G = (ntc=='G');
    C = (ntc=='C');
    A = (ntc=='A');
    T = (ntc=='T');

    ntc(G) = 'C';
    ntc(C) = 'G';
    ntc(T) = 'A';
    ntc(A) = 'T';
end

if L>0
ntc=ntc(:,L);

  aalength = size(ntc,2) / 3;
  aac = ntc(:,1:aalength);
  aac(:) = '@';


  map = geneticcode(1);
  codons = fieldnames(map);
  codons = codons(2:end-1);

  for i=1:aalength
      triplets = (ntc(:,(i-1)*3+1:i*3));
      [utr,~,Y] = unique(triplets,'rows');
      for j=1:size(utr,1)
          IX = (Y==j);
          if Qfix && strcmp(utr(j,:),'TAG')
              aac(IX,i) = 'Q';
          else
              try
              aac(IX,i) = map.(utr(j,:));
              catch
                  if strcmp(utr(j,:),'   ')
                      aac(IX,i)=' ';
                  else
                      aac(IX,i)='X';
                  end
              end
          end
      end
  end
else
    aac='';
end
  
  
end
