function command_center

clear all;
close all;

screen_size=get(0,'ScreenSize');
scr_width=screen_size(3);
scr_height=screen_size(4);


Hfigure = figure('Position',[scr_width*0.15 scr_height*0.7 450 280],...
            'MenuBar','none','NumberTitle','off',...
            'Name','Command Center by R&S', 'DeleteFcn', @fh_delete);

fh = uipanel(Hfigure, 'Title','Panel 1','Position',[0 0 1 1]);          
make_buttons(1,fh);
set_flags;

function make_buttons(N, fh)
        
    x0=0;
    y0=0;
    degugging=1;

                
    if N==1    % button present only in the first group  
        
        UI=[ viewline(x0,115,fh);
             loadline(x0,y0,fh);
             zebraline(x0,45,fh)];
         
        uicontrol(fh,'style','pushbutton',...
                    'string','New Window','tag','New Window', ...
                    'Position', [x0+355 y0+5 80 30],...
                    'callback',@callback_new_button);
                
    elseif N==2 % button present only in the second group  
        UI=[ viewline(x0,115,fh);
             loadline(x0,y0,fh);
             zebraline(x0,45,fh);
             zebraline2D(x0,y0,fh);
             vennline(x0,y0,fh)];
    end
    
    for i=1:numel(UI)
        set(UI{i},'Tag',[get(UI{i},'Tag') num2str(N)]);
    end
    
    
    if degugging             
        uicontrol(fh,'style','pushbutton','string','Show H',...
                    'Position', [x0+5 y0+5 80 30],...
                    'callback',@callback_disp_h);
    end
    
end

function UI = vennline(x0,y0,fh)
    
    UI = cell(9,1);
    UI{1} = uicontrol(fh,'style','pushbutton',...
                'string','XuY','tag','XuY', ...
                'Position', [x0+5 y0+505 60 30],...
                'callback',@callback_function);
            
    UI{2} = uicontrol(fh,'style','pushbutton',...
                'string','XnY','tag','XnY', ...
                'Position', [x0+70 y0+505 60 30],...
                'callback',@callback_function);
            
    UI{3} = uicontrol(fh,'style','pushbutton',...
                'string','YnX','tag','YnX', ...
                'Position', [x0+135 y0+505 60 30],...
                'callback',@callback_function);
            
    UI{4} = uicontrol(fh,'style','pushbutton',...
                'string','X/Y','tag','X/Y', ...
                'Position', [x0+200 y0+505 60 30],...
                'callback',@callback_function);

    UI{5} = uicontrol(fh,'style','pushbutton',...
                'string','Y/X','tag','Y/X', ...
                'Position', [x0+265 y0+505 60 30],...
                'callback',@callback_function);

    UI{6} = uicontrol(fh,'style','pushbutton',...
                'string','Compare','tag','Compare', ...
                'Position', [x0+355 y0+505 80 30],...
                'callback',@callback_function); 
            
    UI{7} = uicontrol(fh,'Style','text',...
                    'String','Uni=','Tag','OverlapUnique',...
                    'Position',[x0+115 y0+280 80 20]);

    UI{8} = uicontrol(fh,'Style','text',...
                    'String','Tot=','Tag','OverlapTotal',...
                    'Position',[x0+205 y0+280 80 20]);
                
    UI{9} = uicontrol(fh,'Style','text','String','view',...
                    'Position',[x0+295 y0+280 60 20]);
               
    UI{10} = uicontrol(fh,'style','popupmenu',...
                    'string','10 lines|100|1000|all',...
                    'tag','OverlapPreviewMenu',...
                    'Position', [x0+345 y0+270 100 30],...
                    'callback',@callback_function); 

    UI{9} = uicontrol(fh,'style','listbox',...
                    'string','Preview Window',...
                    'Tag','OverlapPreviewWindow',...
                    'Position', [x0+5 y0+305 440 195]);  
                
    UI{6} = uicontrol(fh,'style','pushbutton',...
                'string','Save','tag','Save', ...
                'Position', [x0+5 y0+270 80 30],...
                'callback',@callback_function);           
                
end

function UI = loadline(x0,y0,fh)
    inputstring = 'line 1+3|line 2+3|line 3';
    UI = cell(2,1);
        
    UI{1} = uicontrol(fh,'Style','text','String',...
                    'Click browse to load the file',...
                    'Tag','File Name',...
                    'Position',[x0+5 y0+125 220 20]);

    UI{2} = uicontrol(fh,'style','pushbutton',...
                    'String', 'Browse', 'Tag', 'Browse',...
                    'Position', [x0+230 y0+120 60 30],...
                    'callback',@callback_function);

    UI{3} = uicontrol(fh,'style','pushbutton',... 
                    'string','Load Data', 'Tag', 'Load Data',...
                    'Position', [x0+5 y0+80 105 30],...
                    'callback',@callback_function); 

    UI{4} = uicontrol(fh,'Style','text',...
                    'String','Uni=','Tag','Unique',...
                    'Position',[x0+115 y0+80 80 20]);

    UI{5} = uicontrol(fh,'Style','text',...
                    'String','Tot=','Tag','Total',...
                    'Position',[x0+205 y0+80 80 20]);
                
    UI{6} =  uicontrol(fh,'Style','text',...
                    'String','Load','Tag','Sum',...
                    'Position',[x0+290 y0+80 40 20]);
                
    UI{7} =  uicontrol(fh,'Style','popupmenu',...
                    'String',inputstring,'Tag','Select input',...
                    'Position',[x0+330 y0+80 110 20],...
                    'Callback',@callback_function);
end

function UI = zebraline(x0,y0,fh)
    UI = cell(2,1);
    
    UI{1} =  uicontrol(fh,'style','pushbutton',...
                    'string','Plot Zebra','tag','Plot Zebra', ...
                    'Position', [x0+5 y0 80 30],...
                    'callback',@callback_function);

    UI{2} =  uicontrol(fh,'style','checkbox',...
                    'string','NNK only','Tag','NNK Only',...
                    'Position', [x0+95 y0 80 15]);

    UI{3} =  uicontrol(fh,'style','checkbox',...
                    'string','Normal','Tag','Normal',...
                    'Position', [x0+95 y0+15 80 15]);

    UI{4} =  uicontrol(fh,'style','checkbox',...
                    'string','Mirror','Tag','Mirror',...
                    'Position', [x0+185 y0 80 15]);

    UI{5} =  uicontrol(fh,'style','checkbox',...
                    'string','Horizont.','Tag','Horizont',...
                    'Position', [x0+185 y0+15 80 15]);
                
    uicontrol(fh,'style','text','string','x0=',...
                    'Position', [x0+290 y0-5 25 30]); 
                
    UI{6} = uicontrol(fh,'style','edit',...
                    'string',num2str(1),'Tag','x0',...
                    'Position', [x0+315 y0 40 30]); 
                
    uicontrol(fh,'style','text','string','y0=',...
                    'Position', [x0+370 y0-5 26 30]); 
                
    UI{7} = uicontrol(fh,'style','edit',...
                    'string',num2str(0),'Tag','y0',...
                    'Position', [x0+395 y0 40 30]);

end

function UI = zebraline2D(x0,y0,fh) 
    UI = cell(2,1);

    UI{1} = uicontrol(fh,'style','pushbutton',...
                'string','blank','tag','Venn D.', ...
                'Position', [x0+100 y0+5 80 30]); %,...
                %'callback',@callback_function);

    UI{2} = uicontrol(fh,'style','pushbutton',...
                'string','Venn D.','tag','Venn D.', ...
                'Position', [x0+185 y0+5 80 30],...
                'callback',@callback_function);

    UI{3} = uicontrol(fh,'style','pushbutton',...
                'string','X-Y-scatter','tag','X-Y-scatter', ...
                'Position', [x0+270 y0+5 80 30],...
                'callback',@callback_function);

    UI{4} = uicontrol(fh,'style','checkbox',...
                    'string','Ratio','Tag','RatioScatter',...
                    'Position', [x0+350 y0+5 80 15]);

    UI{5} = uicontrol(fh,'style','checkbox',...
                    'string','FlipXY','Tag','FlipXY',...
                    'Position', [x0+350 y0+20 80 15]); 
                
    UI{5} = uicontrol(fh,'style','checkbox',...
                    'string','SymAxis','Tag','SymAxis',...
                    'Position', [x0+350 y0+36 80 15]);             

end

function UI = viewline(x0,y0,fh)  
    
    UI = cell(2,1);
    
    UI{1} = uicontrol(fh,'Style','text','String','view',...
                    'Position',[x0+295 y0+10 60 20]);
               
    UI{2} = uicontrol(fh,'style','popupmenu',...
                    'string','10 lines|100|1000|all','tag','Preview Menu',...
                    'Position', [x0+345 y0 100 30],...
                    'callback',@callback_function); 

    UI{3} = uicontrol(fh,'style','listbox',...
                    'string','Preview Window','Tag','Preview Window',...
                    'Position', [x0+5 y0+35 440 100]);   
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function fh_delete(~,~)
    %close all;
end

function callback_new_button(hO,~)
    FH = get(get(hO,'Parent'),'Parent');
    set(FH,'Position',[scr_width*0.15 scr_height*0.7 2*450 550]);
    h = uipanel(FH, 'Title','Panel 1','Position',[0.5 0 0.5 1]); 
    make_buttons(2,h);
    set_flags;
end

function callback_disp_h(hO,~)
        handles = guidata(hO)
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

end

function set_flags
 % this function recolors buttons to 2D grey
 
    a = findobj;

    for i=1:numel(a)
        if isprop(a(i), 'style')
            if isequal(get(a(i), 'style'),'pushbutton')
                set(a(i), 'BackgroundColor',[1 1 1]);
            end
        end
    end 
end